dojo.require("dojo.event.*");
dojo.require("dojo.fx.*");
dojo.require("dojo.style");

function App(){
}

App.prototype = {
	initialize: function(){
		dojo.debug("initialize");
		var eventForm = dojo.byId("event-creator");
		var self = this;
		eventForm.onsubmit = function(evt) { self.generate(); return false; };
	},
		
	generate: function(){
		dojo.debug("generate");
		this.calendar = new HCalendar();
		this.calendar.summary = dojo.byId("summary").value;
		this.calendar.url = dojo.byId("location").value;
		var start = {
								 year: dojo.byId("startYear").value,
								 month: dojo.byId("startMonth").value,
								 day: dojo.byId("startDay").value,
								 hour: dojo.byId("startHour").value,
								 minute: dojo.byId("startMinute").value 
								}
		var end = {
								 year: dojo.byId("endYear").value,
								 month: dojo.byId("endMonth").value,
								 day: dojo.byId("endDay").value,
								 hour: dojo.byId("endHour").value,
								 minute: dojo.byId("endMinute").value 
								}
		this.calendar.set_startdate(start.year, start.month, start.day,
																start.hour, start.minute);
		this.calendar.set_enddate(end.year, end.month, end.day,
															end.hour, end.minute);
		this.calendar.description = dojo.byId("description");
		
		dojo.byId("eventOutput").value = this.calendar.generate();
		
		// simulate calling various web sites to submit events
		this.submitToSites();
	},
	
	submitToSites: function(){
		var status = dojo.byId("status");
		status.innerHTML = "Submitting event to BackPack...";
		dojo.fx.fadeOut(status, 3000, function(){
			var status = dojo.byId("status");
			status.innerHTML = "";
			dojo.style.setOpacity(status, 100);
			status.innerHTML = "Submitting event to Upcomming...";
			dojo.fx.fadeOut(status, 3000, function(){
				var status = dojo.byId("status");
				status.innerHTML = "";
				dojo.style.setOpacity(status, 100);
				status.innerHTML = "Submitting event to Craigslist...";
				dojo.fx.fadeOut(status, 3000);
			});
		});
	}
}

var app = new App();
dojo.event.connect(dojo, "loaded", app, "initialize");
